// Package eventsapi provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.10.1 DO NOT EDIT.
package eventsapi

import (
	externalRef0 "oransc.org/nonrtric/capifcore/internal/accesscontrolpolicyapi"
	externalRef1 "oransc.org/nonrtric/capifcore/internal/common"
	externalRef2 "oransc.org/nonrtric/capifcore/internal/common29122"
	externalRef3 "oransc.org/nonrtric/capifcore/internal/common29571"
	externalRef4 "oransc.org/nonrtric/capifcore/internal/loggingapi"
	externalRef5 "oransc.org/nonrtric/capifcore/internal/publishserviceapi"
	externalRef6 "oransc.org/nonrtric/capifcore/internal/routinginfoapi"
)

// Defines values for CAPIFEvent.
const (
	CAPIFEventACCESSCONTROLPOLICYUNAVAILABLE CAPIFEvent = "ACCESS_CONTROL_POLICY_UNAVAILABLE"

	CAPIFEventACCESSCONTROLPOLICYUPDATE CAPIFEvent = "ACCESS_CONTROL_POLICY_UPDATE"

	CAPIFEventAPIINVOKERAUTHORIZATIONREVOKED CAPIFEvent = "API_INVOKER_AUTHORIZATION_REVOKED"

	CAPIFEventAPIINVOKEROFFBOARDED CAPIFEvent = "API_INVOKER_OFFBOARDED"

	CAPIFEventAPIINVOKERONBOARDED CAPIFEvent = "API_INVOKER_ONBOARDED"

	CAPIFEventAPIINVOKERUPDATED CAPIFEvent = "API_INVOKER_UPDATED"

	CAPIFEventAPITOPOLOGYHIDINGCREATED CAPIFEvent = "API_TOPOLOGY_HIDING_CREATED"

	CAPIFEventAPITOPOLOGYHIDINGREVOKED CAPIFEvent = "API_TOPOLOGY_HIDING_REVOKED"

	CAPIFEventSERVICEAPIAVAILABLE CAPIFEvent = "SERVICE_API_AVAILABLE"

	CAPIFEventSERVICEAPIINVOCATIONFAILURE CAPIFEvent = "SERVICE_API_INVOCATION_FAILURE"

	CAPIFEventSERVICEAPIINVOCATIONSUCCESS CAPIFEvent = "SERVICE_API_INVOCATION_SUCCESS"

	CAPIFEventSERVICEAPIUNAVAILABLE CAPIFEvent = "SERVICE_API_UNAVAILABLE"

	CAPIFEventSERVICEAPIUPDATE CAPIFEvent = "SERVICE_API_UPDATE"
)

// AccessControlPolicyListExt defines model for AccessControlPolicyListExt.
type AccessControlPolicyListExt struct {
	// Embedded struct due to allOf(TS29222_CAPIF_Access_Control_Policy_API.yaml#/components/schemas/AccessControlPolicyList)
	externalRef0.AccessControlPolicyList `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ApiId *string `json:"apiId,omitempty"`
}

// Possible values are:
// - SERVICE_API_AVAILABLE: Events related to the availability of service APIs after the service APIs are published.
// - SERVICE_API_UNAVAILABLE: Events related to the unavailability of service APIs after the service APIs are unpublished.
// - SERVICE_API_UPDATE: Events related to change in service API information.
// - API_INVOKER_ONBOARDED: Events related to API invoker onboarded to CAPIF.
// - API_INVOKER_OFFBOARDED: Events related to API invoker offboarded from CAPIF.
// - SERVICE_API_INVOCATION_SUCCESS: Events related to the successful invocation of service APIs.
// - SERVICE_API_INVOCATION_FAILURE: Events related to the failed invocation of service APIs.
// - ACCESS_CONTROL_POLICY_UPDATE: Events related to the update for the access control policy related to the service APIs.
// - ACCESS_CONTROL_POLICY_UNAVAILABLE: Events related to the unavailability of the access control policy related to the service APIs.
// - API_INVOKER_AUTHORIZATION_REVOKED: Events related to the revocation of the authorization of API invokers to access the service APIs.
// - API_INVOKER_UPDATED: Events related to API invoker profile updated to CAPIF.
// - API_TOPOLOGY_HIDING_CREATED: Events related to the creation or update of the API topology hiding information of the service APIs after the service APIs are published.
// - API_TOPOLOGY_HIDING_REVOKED: Events related to the revocation of the API topology hiding information of the service APIs after the service APIs are unpublished.
type CAPIFEvent string

// Represents a CAPIF event details.
type CAPIFEventDetail struct {
	// Represents the extension for access control policies.
	AccCtrlPolList *AccessControlPolicyListExt `json:"accCtrlPolList,omitempty"`

	// Identifier of the service API
	ApiIds *[]string `json:"apiIds,omitempty"`

	// Identity of the API invoker
	ApiInvokerIds *[]string `json:"apiInvokerIds,omitempty"`

	// Represents the routing rules information of a service API.
	ApiTopoHide *TopologyHiding `json:"apiTopoHide,omitempty"`

	// Invocation logs.
	InvocationLogs *[]externalRef4.InvocationLog `json:"invocationLogs,omitempty"`

	// Description of the service API as published by the APF.
	ServiceAPIDescriptions *[]externalRef5.ServiceAPIDescription `json:"serviceAPIDescriptions,omitempty"`
}

// Represents a CAPIF event filter.
type CAPIFEventFilter struct {
	// Identifier of the API exposing function
	AefIds *[]string `json:"aefIds,omitempty"`

	// Identifier of the service API
	ApiIds *[]string `json:"apiIds,omitempty"`

	// Identity of the API invoker
	ApiInvokerIds *[]string `json:"apiInvokerIds,omitempty"`
}

// Represents an individual CAPIF Event notification.
type EventNotification struct {
	// Represents a CAPIF event details.
	EventDetail *CAPIFEventDetail `json:"eventDetail,omitempty"`

	// Possible values are:
	// - SERVICE_API_AVAILABLE: Events related to the availability of service APIs after the service APIs are published.
	// - SERVICE_API_UNAVAILABLE: Events related to the unavailability of service APIs after the service APIs are unpublished.
	// - SERVICE_API_UPDATE: Events related to change in service API information.
	// - API_INVOKER_ONBOARDED: Events related to API invoker onboarded to CAPIF.
	// - API_INVOKER_OFFBOARDED: Events related to API invoker offboarded from CAPIF.
	// - SERVICE_API_INVOCATION_SUCCESS: Events related to the successful invocation of service APIs.
	// - SERVICE_API_INVOCATION_FAILURE: Events related to the failed invocation of service APIs.
	// - ACCESS_CONTROL_POLICY_UPDATE: Events related to the update for the access control policy related to the service APIs.
	// - ACCESS_CONTROL_POLICY_UNAVAILABLE: Events related to the unavailability of the access control policy related to the service APIs.
	// - API_INVOKER_AUTHORIZATION_REVOKED: Events related to the revocation of the authorization of API invokers to access the service APIs.
	// - API_INVOKER_UPDATED: Events related to API invoker profile updated to CAPIF.
	// - API_TOPOLOGY_HIDING_CREATED: Events related to the creation or update of the API topology hiding information of the service APIs after the service APIs are published.
	// - API_TOPOLOGY_HIDING_REVOKED: Events related to the revocation of the API topology hiding information of the service APIs after the service APIs are unpublished.
	Events CAPIFEvent `json:"events"`

	// Identifier of the subscription resource to which the notification is related – CAPIF resource identifier
	SubscriptionId string `json:"subscriptionId"`
}

// Represents an individual CAPIF Event Subscription resource.
type EventSubscription struct {
	// Subscribed event filters
	EventFilters *[]CAPIFEventFilter `json:"eventFilters,omitempty"`

	// Represents the type of reporting that the subscription requires.
	EventReq *externalRef1.ReportingInformation `json:"eventReq,omitempty"`

	// Subscribed events
	Events []CAPIFEvent `json:"events"`

	// string providing an URI formatted according to IETF RFC 3986.
	NotificationDestination externalRef2.Uri `json:"notificationDestination"`

	// Set to true by Subscriber to request the CAPIF core function to send a test notification as defined in in clause 7.6. Set to false or omitted otherwise.
	RequestTestNotification *bool `json:"requestTestNotification,omitempty"`

	// A string used to indicate the features supported by an API that is used as defined in clause  6.6 in 3GPP TS 29.500. The string shall contain a bitmask indicating supported features in  hexadecimal representation Each character in the string shall take a value of "0" to "9",  "a" to "f" or "A" to "F" and shall represent the support of 4 features as described in  table 5.2.2-3. The most significant character representing the highest-numbered features shall  appear first in the string, and the character representing features 1 to 4 shall appear last  in the string. The list of features and their numbering (starting with 1) are defined  separately for each API. If the string contains a lower number of characters than there are  defined features for an API, all features that would be represented by characters that are not  present in the string are not supported.
	SupportedFeatures *externalRef3.SupportedFeatures `json:"supportedFeatures,omitempty"`

	// Represents the configuration information for the delivery of notifications over Websockets.
	WebsockNotifConfig *externalRef2.WebsockNotifConfig `json:"websockNotifConfig,omitempty"`
}

// Represents the routing rules information of a service API.
type TopologyHiding struct {
	ApiId        string                     `json:"apiId"`
	RoutingRules []externalRef6.RoutingRule `json:"routingRules"`
}

// PostSubscriberIdSubscriptionsJSONBody defines parameters for PostSubscriberIdSubscriptions.
type PostSubscriberIdSubscriptionsJSONBody EventSubscription

// PostSubscriberIdSubscriptionsJSONRequestBody defines body for PostSubscriberIdSubscriptions for application/json ContentType.
type PostSubscriberIdSubscriptionsJSONRequestBody PostSubscriberIdSubscriptionsJSONBody
